# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%if "%{?rhel}" == "6"
%define _jarsign_opts --unsign=%{_javadir}
%bcond_without repolib
%else
%bcond_with repolib
%endif
%bcond_without mead

%define repodir %{_javadir}/repository.jboss.com/jboss/common-logging-jdk/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free
%define namedversion %{version}.GA

Name:           jboss-common-logging-jdk
Version:        2.1.2
Release:        1%{?dist}
Epoch:          0
Summary:        JBoss Logging JDK Implementation
License:        LGPLv2+
URL:            http://www.jboss.org/
Group:          Development/Libraries/Java
# svn -q export http://anonsvn.jboss.org/repos/common/common-logging-jdk/tags/2.1.2.GA/ jboss-common-logging-jdk-2.1.2
# Exported revision 4854.
# tar cjf jboss-common-logging-jdk-2.1.2.tar.bz2 jboss-common-logging-jdk-2.1.2
%if %without mead
Source0:        %{name}-%{version}.tar.bz2
%endif
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        jboss-common-logging-jdk-component-info.xml
Requires:       java >= 0:1.5.0
Requires:       jboss-common-core >= 0:2.2.5
Requires:       jboss-common-logging-spi >= 0:2.1.2
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
%if %with mead
BuildRequires:  %{name}-mead = %{namedversion}
%else
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jboss-common-core >= 0:2.2.5
BuildRequires:  jboss-common-logging-spi >= 0:2.1.2
BuildRequires:  jboss-deploy-maven-plugin
BuildRequires:  jboss-parent
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-default-skin
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:	velocity15
%endif

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Logging JDK Implementation.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %without mead
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

find . -name "*.jar" -exec rm -f {} \;
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
export M2_SETTINGS=$(pwd)/settings.xml
mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc site
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%add_to_maven_depmap org.jboss.logging jboss-logging-jdk %{namedversion} JPP %{name}

%if %without mead
install -p -m 644 target/jboss-logging-jdk-%{namedversion}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%else
install -p -m 644 %{_javadir}/jbossas-fordev/jboss-logging-jdk-%{namedversion}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -p -m 644 %{_javadir}/jbossas-fordev/jboss-logging-jdk-%{namedversion}-sources.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
%endif

pushd $RPM_BUILD_ROOT%{_javadir}
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jboss-logging-jdk-%{version}.jar
ln -s %{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/jboss-logging-jdk-%{version}-sources.jar
popd

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%if %without mead
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%else
install -p -m 644 %{_javadir}/jbossas-fordev/jboss-logging-jdk-%{namedversion}.pom \
           $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %without mead
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
pushd $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
unzip -q %{_javadir}/jbossas-fordev/jboss-logging-jdk-%{namedversion}-javadoc.jar
popd
%endif
# FIXME: (dwalluck): breaks -bi --short-circuit
rm -rf target/site/apidocs
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %without mead
## manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

%if %with repolib
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{namedversion}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%if %without mead
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%else
%{__install} -p -m 644 %{_javadir}/jbossas-fordev/org.jboss.logging-jboss-logging-jdk-%{namedversion}-sources.zip %{buildroot}%{repodirsrc}
%endif
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/jboss-logging-jdk.jar
%{__cp} -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/jboss-logging-jdk.pom

%if %without mead
%{__install} -p -m 755 %{SOURCE4} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}-%{version}-sources.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-sources.jar
%{_javadir}*/jboss-logging-jdk-%{version}.jar
%{_javadir}*/jboss-logging-jdk-%{version}-sources.jar
%{_javadir}*/jboss-logging-jdk.jar
%{_javadir}*/jboss-logging-jdk-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %without mead
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Feb 14 2011 Fernando Nasser <fnasser@redhat.com> 0:2.1.2-1
- Upgrade to 2.1.2.GA
- Move compilation to MEAD

* Mon Jun 7 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.1.1-1.1.1
- rebuild 

* Fri May 28 2010 Yong Yang <yyang@redhat.com> 0:2.1.1-1.1
- Merge with RHEL-4-EP-5

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.0-2.2.1
- Rebuilt
- Add BR velocity15

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redha.com> 0:2.1.0-2.2
- Rebuild

* Fri Jun 12 2009 Martha Benitez <mbenitez@redhat.com> 0:2.1.0-2.1
- Change jpackage-utils >= 0:1.7.5 to jpackage-utils >= 0:1.7.3
- Change BR jboss-parent3 to jboss-parent

* Tue May 26 2009 David Walluck <dwalluck@redhat.com> 0:2.1.0-2
- enable site

* Thu May 21 2009 David Walluck <dwalluck@redhat.com> 0:2.1.0-1
- 2.1.0.GA

* Tue Feb 10 2009 David Walluck <dwalluck@redhat.com> 0:2.0.5-1
- release
